var MOBILE_SERVICES_URL = 'http://mobileservice.websiteforge.com';
var APP_NAME = 'TKDSCORE';
var DEVICE_INFO = '';
var REG_ID;
var LOCATION_DATA;
var GDOCSPAGES = {
  'wholesale':                  "1tToMyN20Ieu5EQFF7fvIXvYfybfInZG4aakn1OSN4hA/pub",
  'bare_essential_concussion':  '10NyaoE1aghFEZaI9-SbaQcBjBuLFRVB1jJY1UleJXH8/pub',
  'bare_essential_hydration':   '1eNBD2y9ftY80KdVo3Bp7NzKOSwFpwhrfOu10yZGXIf4/pub',
  'daedo_rentals':              '1SmausLu6XoNpzZBMjiw_nUkNoDU86XD5jPF7Vz0mK8o/pub',
  'tournaments':                '18kb3ehyq4OEcCbYWT4bv8d1PxNWTQPVTCpbjwwGWskA/pub',
  'notifications':              '1l4a-zNAXCwa8PFW0GmL6AEMtNzg6Tp861I8xb6otufY/pub',
  'wocoku' :                    '1qyJDY6DO2b-vSmzfMQNrVCrlxv4Ax_rOpaki8Z-rC7o/pub',
  'daedo':                      '1SBeKHxGEnEFwTnh-uNDfW54XcOBYnqXu3SSOyZ0u5Mk/pub'    
};
var EXTERNAL_PAGES = {
  'thresholds': 'http://www.tkdscore.com/uploaded/thresholds_mobile.html',
  'customs': 'http://www.tkdscore.com/custom/uploaded/tshirts/'
}
var MENU_PAGE_CACHE = "";

var EMERGENCY_TIMEOUT = false;

var app = {
    platform: false,
    is_android: function(){ return app.platform == 'android'; },
    is_ios: function(){ return app.platform == 'ios'; },

    receivedEvent: function(e){
      console.log("receivedEvent", e);
    },

    applicationLoaded: false,
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.platform = ( device.platform == 'android' || device.platform == 'Android' ) ? 'android' : 'ios';

        // renderInnerPage('tournament');
        // hideLoading();
        // return;

        // If something weird happend load application
        EMERGENCY_TIMEOUT = setTimeout(function(){
          console.log('emergency load of app');
          loadApplication();
        }, 3000);

        loading('Checking Internet Connection');
        app.checkConnection();
        app.pushInit();
        app.geolocation();
        app.handleExternalURLs();
        
        window.analytics.startTrackerWithId('UA-62991829-1');

        document.addEventListener("backbutton", function(e){
           if($('.home_screen').length > 0){
               e.preventDefault();
               navigator.app.exitApp();
           }else{
               // navigator.app.backHistory()
               loadApplicationMobile();
           }
        }, false);

        StatusBar.hide(); // was show
        if ( app.is_ios() ){
            cordova.exec(null, null, 'StatusBar', 'hide', ['Ehi', 'You']);    
        }

        // try to get menu from server
        $.ajax({
            url: 'http://www.tkdscore.com/uploaded/load-application.html',
            cache: true,
            success: function(html){
                console.log('Menu loaded from internet');

                // Remove last line, js-defer script added by wsf
                if(html.lastIndexOf("\n")>0)
                  html =  html.substring(0, html.lastIndexOf("\n"));
                
                MENU_PAGE_CACHE = html;
            },
            error: function(xhr, textStatus, error){
                MENU_PAGE_CACHE = false;
            }
        });

        console.log('everything loaded');
    },

    pushInit: function(){
      console.log(' New Push Init');

      if ( app.is_android() ){
          var deviceInfo = cordova.require("cordova/plugin/DeviceInformation");
          deviceInfo.get(function(result) {
              console.log("DEVICE_INFO result = " + result);
              DEVICE_INFO = result;
          }, function() {
              console.log("error retrieving device info.");
          });
      }

      var pushNotification = window.plugins.pushNotification;
      var push = PushNotification.init({
          android: {
              senderID: "744081151385",
              icon: "ic_stat_tkdscore_icon"
          },
          browser: {
              pushServiceURL: 'http://push.api.phonegap.com/v1/push'
          },
          ios: {
              alert: "true",
              badge: "true",
              sound: "true"
          },
          windows: {}
      });

      push.on('registration', function(data) {
          // data.registrationId
          console.log('-----------------------------------------');
          console.log('New Push Registration');
          console.log(data);
          console.log('-----------------------------------------');
          REG_ID = data.registrationId;
          var data = {
              'platform': device.platform.toLowerCase(), 
              'regid':    REG_ID,
              'app':      APP_NAME, 
              'data':     DEVICE_INFO
          };

          if (typeof LOCATION_DATA != 'undefined')
            data = $.extend(data, LOCATION_DATA);

          $.post(MOBILE_SERVICES_URL+'/register.php', data, function(result){
            console.log('Registered on WSF MS: '+result);
          });

          if ($('body').hasClass('notification')) { return; };
          loadApplication();
      });

      push.on('notification', function(data) {
        console.log('-----------------------------------------');
        console.log('New Push Notification');
        console.log(data);
        console.log('-----------------------------------------');
          // data.message,
          // data.title,
          // data.count,
          // data.sound,
          // data.image,
          // data.additionalData

          if (app.is_ios) {
            if ( data.sound ){
                var snd = new Media(data.sound);
                snd.play();
            }

            if ( data.count )
              pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, data.count);
          }

          if (data.message != 'Welcome!') {
            console.log('Notification received');
            $('body').addClass('notification');
            renderInnerPage('notifications');
            alert(data.message);
          };
      });

      push.on('error', function(e) {
          // e.message
          console.log('-----------------------------------------');
          console.log('New Push Error');
          console.log(e);
          console.log('-----------------------------------------');
      });

    },

    geolocation: function(){
        loading('Obtaining Location');

        var locationOnSuccess = function(position) {
            loading('Loading news...');
            console.log('Latitude: '    + position.coords.latitude          + '\n' +
                  'Longitude: '         + position.coords.longitude         + '\n' +
                  'Altitude: '          + position.coords.altitude          + '\n' +
                  'Accuracy: '          + position.coords.accuracy          + '\n' +
                  'Altitude Accuracy: ' + position.coords.altitudeAccuracy  + '\n' +
                  'Heading: '           + position.coords.heading           + '\n' +
                  'Speed: '             + position.coords.speed             + '\n' +
                  'Timestamp: '         + position.timestamp                + '\n');

            LOCATION_DATA = {
              'latitude':   position.coords.latitude,
              'longitude':  position.coords.longitude,
              'altitude':   position.coords.altitude,
              'accuracy':   position.coords.accuracy
            };
            
            $.post('http://gps.tkdscore.com/receiver.php', LOCATION_DATA, function(r){ 
              console.log('GPS receiver.php result: '+r);
            });
            
            app.receivedEvent('deviceready');
        };

        var locationOnError = function(error) {
            console.log('GPS Error'+error);
            //alert('Is not possible to obtain your location. You MUST have location enabled to use this app. Please check that your location settings are enabled and try again.');
            //cordova.plugins.diagnostic.switchToLocationSettings();
            //navigator.app.exitApp();


            console.log("The geo error : " + error.code +"code : " + error.PERMISSION_DENIED);
            if( error.code == error.PERMISSION_DENIED ){
              alert("Please enable your location settings to use the application");
            }else{
              console.log("Gps is turned on. but not availabile");
            }
        }

        cordova.plugins.diagnostic.isLocationEnabled(
          function(){ //success
              console.log('Location enabled...');
              var options = {maximumAge: 200000, timeout: 5000, enableHighAccuracy:true};
              navigator.geolocation.getCurrentPosition(locationOnSuccess, locationOnError, options);
          }, 
          function(){ //failure
              console.log('Location not enabled');
              onError(0);
          }
        );

        
        console.log('GPS checked finished');
    },

    checkConnection: function() {
        try{
              var networkState = navigator.connection && navigator.connection.type;

              setTimeout(function(){
                  networkState = navigator.connection && navigator.connection.type;

                  var states = {};
                  states[Connection.UNKNOWN]  = 'Unknown connection';
                  states[Connection.ETHERNET] = 'Ethernet connection';
                  states[Connection.WIFI]     = 'WiFi connection';
                  states[Connection.CELL_2G]  = 'Cell 2G connection';
                  states[Connection.CELL_3G]  = 'Cell 3G connection';
                  states[Connection.CELL_4G]  = 'Cell 4G connection';
                  states[Connection.NONE]     = 'No network connection';

                  console.log('Connection type: ' + states[networkState]);

                  if (networkState == Connection.NONE){
                    console.log('No Internet');
                    alert('no internet ');
                  };
              }, 500);
          }catch(e){
              console.log("Network error: "+e);
              $.each(navigator, function(key, value){
                  console.log(key+' => '+value);
              });
          }

        
    },

    handleExternalURLs: function() {
        // Handle click events for all external URLs
        if (device.platform.toUpperCase() === 'ANDROID') {
            $(document).on('click', 'a[target="_blank"]', function (e) {
                var url = $(this).attr('href');
                navigator.app.loadUrl(url, { openExternal: true });
                e.preventDefault();
            });
        }
        else if (device.platform.toUpperCase() === 'IOS') {
            $(document).on('click', 'a[target="_blank"]', function (e) {
                var url = $(this).attr('href');
                window.open(url, '_system');
                e.preventDefault();
            });
        }
        else {
            // Leave standard behaviour
        }
    },

    loadAllPagesFromGoogleDocs: function(){},

    loadFromGoogleDocs: function(name){
      console.log('loading gdocs '+name);
      if (name in GDOCSPAGES) {
        

        var doc_url = 'https://docs.google.com/document/d/' + GDOCSPAGES[name] + ' #contents';
        var css_id  = 'gdoc-'+name+''; 
        var $target_element;

        $target_element = $("#"+name+'_target');
        if ($target_element.length == 0) {
          $target_element = $(".page-content .page-text");  
        };

        if (name+'_content' in GDOCSPAGES) {
          return $target_element.html( GDOCSPAGES[name+'_content'] );
        };

        loading(name);
        // $.get(doc_url, function(response){
        $('<div></div>').load(doc_url, function(response, status, xhr){
              if (status == 'error') {
                alert('Please check your internet connection and try again');
                loadApplication();
                return;
              };
              // fix to image withd
              $(this).find('img').parents('span').css({height: 'auto' ,maxWidth: '100%'});
              $(this).find('img').css({height: 'auto' ,maxWidth: '100%'});

              // Fix to inline css
              style = $(this).find('style').html();
              style = style.replace(/font-family:"Trebuchet MS"/g, '');
              style = style.replace(/font-family:"Arial"/g, '');
              style = style.replace(/color:#000000/g, '');
              style = style.replace(/font-size:11pt/g, '');
              style = style.replace(/margin-left:36pt/g, '');
              style = style.replace(/(}|^)([^{]+?){/gi, "$1#"+css_id+" $2{");
              $(this).find('style').html(style);
              // console.log(style);

              // replace links to have target=blank and fix links
              $(this).find('a').each(function(){
                var href = $(this).attr('href');
                if (typeof href == 'undefined') { $(this).remove(); return};

                if (href.indexOf('http://www.google.com/url?q=') != -1) {
                  href = href.replace("http://www.google.com/url?q=", '');
                  if (href.indexOf('&sa=') != -1) {
                    href = href.substr(0, href.indexOf('&sa='));
                  };
                  href = decodeURIComponent(href);
                  $(this).attr('href', href).attr('target', '_blank');
                };
              });              

              GDOCSPAGES[name+'_content'] = '<div class="gdoc" id="'+css_id+'">'+$(this).html()+'</div>';

              $target_element.html( GDOCSPAGES[name+'_content'] );

              hideLoading();
          });
      };

      return false;
      
    }


};

function loadApplication(){

    console.log('Executing loadApplication');
    $('#loadmoreajaxloader').show();

    try{
      app.applicationLoaded = true;
      window.analytics.setUserId(REG_ID);
      window.analytics.trackView('HomePage');  
    }catch(e){
      console.log(e);
    }
    
    // app.loadPagesFromGoogleDocs();

    $.ajax({
        // type: 'POST', 
        url: 'website/load-application.html',
        // cache: false,
        success: function(html){
            if (MENU_PAGE_CACHE && MENU_PAGE_CACHE != "") {
              html = MENU_PAGE_CACHE;
            }
            
            hideLoading();
            $('#loadmoreajaxloader').hide();
            //$("#simulatior-loader").hide();
            $("#screenshot").html(html);
            $('.close').attr('style','display:none');
            
            var existClass=$('ul').hasClass('app_navigation_bottom');
            if(existClass){
                var firstBottomSelect=$('ul.app_navigation_bottom li:first').attr("id");
                var seleltdefaultd=firstBottomSelect.split('-');
                renderInnerPage(seleltdefaultd[1]);
            }
        },
        error: function(xhr, textStatus, error){
            alert(error);
        }
    });
}

function renderInnerPage(id){ 
    console.log('renderInnerPage: '+id);
    window.analytics.trackView(id);

    clearTimeout(EMERGENCY_TIMEOUT);

    var processPage = function(html){
        $("#screenshot #main-theme").html(html);
        //$('#simulatior-loader').hide();   
        $('.photo_close').attr('style','display:none');

        if (id in GDOCSPAGES) {
          $(".page-content .page-text").html('');
          app.loadFromGoogleDocs(id);
        }else{
          if (id in EXTERNAL_PAGES) {
            console.log("Loading external page: "+id);
            loading('Getting latest data');
            
            $target_element = $("#screenshot #main-theme");
            
            if (id+'_content' in EXTERNAL_PAGES) {
              console.log('restored from cache');
              $target_element.html( GDOCSPAGES[id+'_content'] );
              return hideLoading();
            };

            $('<div></div>').load(EXTERNAL_PAGES[id], function(response, status, xhr){
                if (status == 'error') {
                  console.log('Internet connection not enabled, displaying from cache')
                  return hideLoading();
                };

                $(this).find('script[src]').remove(); // to avoid error due to wsf js pagespeed
                response = $(this).html().replace(/type="text\/psajs"/g, 'type="text/javascript"');
                EXTERNAL_PAGES[id+'_content'] = '<div class="external_page" id="'+id+'">'+response+'</div>';

                $target_element.html( EXTERNAL_PAGES[id+'_content'] );

                hideLoading();
            });
          };
        };
    };
    
    $.get("website/"+id+".html", processPage)
      .fail(processPage);
   
    $('#loadmoreajaxloader').hide();

}

function renderExternalPage(url){
  console.log('renderExternalPage: '+url);
  window.analytics.trackView(url);
  loading('Please wait a moment...');

  setTimeout(function(){ hideLoading(); }, 3500);

  $("#screenshot #main-theme").load('website/generic.html', function(){
    var $target_element = $("#screenshot #main-theme");
    $('<div></div>').load(url, function(response, status, xhr){
        if (status == 'error') {
          console.log('Internet connection not enabled, displaying from cache');
          return hideLoading();
        };

        // use full host for assets
        $(this).find('[src]').each(function(){ $(this).attr('src', 'http://www.tkdscore.com/custom/uploaded/tshirts/'+$(this).attr('src')) });
        $(this).find('link[href]').each(function(){ $(this).attr('href', 'http://www.tkdscore.com/custom/uploaded/tshirts/'+$(this).attr('href')) });
        // remove assets that should be ignored on tkdscore app
        $(this).find('[ignore-on-tkd-app], meta').remove();

        EXTERNAL_PAGES[url + '_content'] = '<div class="external_page" id="'+url+'">'+$(this).html()+'</div>';

        $('#main_content').html( EXTERNAL_PAGES[url+'_content'] );

        $(function(){
          hideLoading();
        });
    });
  });
}

function loading(text){
  console.log("Loading: "+text);
  $('#loading span').text(text);
  $('#loading').show();
}
function hideLoading(){
  $('#loading span').text('');
  $('#loading').hide();
}