var scripts = document.getElementsByTagName('script');
var index = scripts.length - 1;
var myScript = scripts[index];
// myScript now contains our script object
var queryString = myScript.src.replace(/^[^\?]+\??/,'');
var languageArray=queryString.split("=");
var language=languageArray[1];
var messagesDictionary = {
    en: {
    CANNOT_DETER:'Cannot determine address at this location',
	DRAG:'Drag to locate your area'
	},

	nl: {
    CANNOT_DETER:'Adres op deze locatie kan niet worden vastgesteld',
	DRAG:'Sleep om je omgeving te lokaliseren'
	},

	cn: {
    CANNOT_DETER:'在这个位置无法确定地址',
	DRAG:'拖动定位您所在区域'
	},

	de: {
    CANNOT_DETER:'Kann nicht feststellen Adresse an dieser Stelle',
	DRAG:'Ziehen Sie, um Ihrer Nähe zu finden'
    },

	fr: {
    CANNOT_DETER:'Impossible de déterminer l`adresse à cet endroit',
	DRAG:'Faites glisser pour localiser votre région'
	},

    sa: {
    CANNOT_DETER:'اس مقام پر ایڈریس کا تعین نہیں کر سکتے ہیں',
	DRAG:'آپ کے علاقے کو تلاش کرنے کے لئے ھیںچیں'
	
		},
	 es: {
    CANNOT_DETER:'No se puede determinar la dirección en esta ubicación',
	DRAG:'Arrastre para localizar el área'
	
    },

	ja: {
    CANNOT_DETER:'この場所にアドレスを決定することはできません。',
	DRAG:'ドラッグして、お住まいの地域を検索します'
	},
	
	 

}

var geocoder = new google.maps.Geocoder(); 
   
function geocodePosition(pos) { 
  geocoder.geocode({ 
    latLng: pos 
  }, function(responses) { 
    if (responses && responses.length > 0) { 
      updateMarkerAddress(responses[0].formatted_address); 
    } else { 
      updateMarkerAddress(messagesDictionary[language]['CANNOT_DETER']); 
    } 
  }); 
} 

function updateMarkerPosition(latLng) {  
  
  document.getElementById('latLatitude_1').value = [latLng.lat()];
  document.getElementById('latLongitude_1').value = [ latLng.lng()];
} 

function updateMarkerAddress(str) { 
	//$("#contact_address").val(str);
} 

function initialize(lat,lang,divid) {
  var latLng = new google.maps.LatLng(lat,lang); 
  var map = new google.maps.Map(document.getElementById(divid), { 
    zoom: 15,
    zoomControl: true,
    panControl: false,
    disableDefaultUI: false,
    scaleControl: false,
    mapTypeControl: false,
    streetViewControl: false,
    overviewMapControl: false,
    center: latLng, 
    mapTypeId: google.maps.MapTypeId.ROADMAP 
  }); 
  var marker = new google.maps.Marker({ 
    position: latLng, 
    title: ' '+latLng+' ', 
    map: map, 
   // icon : 'http://s3.amazonaws.com/appypie/mapicon.png',
    draggable: false 
  }); 
 
  // Update current position info. 
  //updateMarkerPosition(latLng); 
 // geocodePosition(latLng); 
   
  // Add dragging event listeners. 
  google.maps.event.addListener(marker, 'dragstart', function() { 
    
  }); 
   
  google.maps.event.addListener(marker, 'drag', function() { 
    updateMarkerPosition(marker.getPosition()); 
  }); 
   
  google.maps.event.addListener(marker, 'dragend', function() { 
    geocodePosition(marker.getPosition()); 
  }); 
   
  google.maps.event.addListener(map, 'bounds_changed', function(){ 
    var newgeo = map.get('center'); 
     var newzoom = map.get('zoom'); 
    
  }); 
        
}

// map with add marker (pin)
function initializeMapPin(lat,lang,divid,id)
{
	var maplatlng = new Array(); 
	var mapcounter = parseInt(document.getElementById("counter"+id).value);
//alert(lat); alert(lang);
	var myCenter=new google.maps.LatLng(lat,lang);
	var mapProp = {
		zoom: 15,
		zoomControl: true,
		panControl: false,
		disableDefaultUI: false,
		scaleControl: false,
		mapTypeControl: false,
		streetViewControl: false,
		overviewMapControl: false,
		center:myCenter,
		mapTypeId:google.maps.MapTypeId.ROADMAP
	};

	 map = new google.maps.Map(document.getElementById(divid),mapProp);
	 //for (i = 0; i < mapcounter; i++) {
		var markerlat = $('#latLatitude'+id).val();
		var markerlng = $('#latLongitude'+id).val();
		if(markerlat!="" && markerlng!=""){
			maplatlng = new google.maps.LatLng(markerlat,markerlng);
			var markervar = 'marker'+id
			markervar = new google.maps.Marker({
				map:map,
				draggable:true,
				position: maplatlng,
				id: id
				
			});
			
			google.maps.event.addListener(markervar, 'click', function(marker){
				var counterval = $('#counter_'+this.id).val();
				$('#latLatitude'+this.id).val('');
				$('#latLongitude'+this.id).val('');
				this.setMap(null);
				//initializeMapPin(lat,lang,divid,id);
				saveContactData();
			});
			google.maps.event.addListener(markervar, 'dragend', function(event) {
				placeMarker(event.latLng,lat,lang,divid,id);
			});
		}
	 //}
	google.maps.event.addListener(map, 'click', function(event) {
		placeMarker(event.latLng,lat,lang,divid,id);
	});
	
}
function placeMarker(location,lat,lang,divid,id) {
	initializeMapPin(lat,lang,divid,id);
	var mapcounter = parseInt(document.getElementById("counter"+id).value);
	var markervar = 'marker_'+mapcounter;
	var markervar = new google.maps.Marker({
		position: location,
		map: map,
		draggable: false,
	});
	//document.getElementById("counter"+id).value = mapcounter+1;
	var htmlcontmpap = '<input type="hidden" id="latLatitude'+id+'" name="latLatitude'+id+'"><input type="hidden" id="latLongitude'+id+'" name="latLongitude'+id+'">';
	$('#map_latlng'+id).html(htmlcontmpap);
	document.getElementById("latLatitude"+id).value = location.lat();
	document.getElementById("latLongitude"+id).value = location.lng();
	initializeMapPin(lat,lang,divid,id);
	saveContactData();
	/*var infowindow = new google.maps.InfoWindow({
		content: 'Latitude: ' + location.lat() + '<br>Longitude: ' + location.lng()
	});*/
	
  
	google.maps.event.addListener(markervar, 'dragend', function(marker){
		var latLng = marker.latLng;
		//alert("lat :"+latLng.lat() +"\n long:"+latLng.lng());
		document.getElementById("latLatitude"+id).value = latLng.lat();
		document.getElementById("latLongitude"+id).value = latLng.lng();
		var infowindow = new google.maps.InfoWindow({
			content: 'Latitude: ' + latLng.lat() + '<br>Longitude: ' + latLng.lng()
		});
	});
	//infowindow.open(map,marker);
	
}


